diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.c freeciv-patched/server/ruleset.c
--- freeciv-cvs/server/ruleset.c	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/server/ruleset.c	2003-06-30 12:18:10.000000000 +0100
@@ -74,6 +74,7 @@
 
 static void load_tech_names(struct section_file *file);
 static void load_unit_names(struct section_file *file);
+static void load_unit_userflags(struct section_file *file);
 static void load_building_names(struct section_file *file);
 static void load_government_names(struct section_file *file);
 static void load_terrain_names(struct section_file *file);
@@ -661,6 +662,242 @@
 }
 
 /**************************************************************************
+  ...  
+**************************************************************************/
+static void load_unit_userflags(struct section_file *file)
+{
+  char **slist;
+  int nval, i;
+
+  game.num_unit_flags = F_LAST;
+  slist = secfile_lookup_str_vec(file, &nval, "userflags.names");
+  if (nval > F_MAX - F_LAST) {
+    freelog(LOG_ERROR, "Too many user-specified unit flags (%d, max %d)",
+	    nval, F_MAX - F_LAST);
+    exit(EXIT_FAILURE);
+  }
+
+  game.num_unit_flags = F_LAST + nval;
+  for (i = 0; i < nval; ++i) {
+    unit_flag_set_name(F_LAST + i, slist[i]);
+  }
+  free(slist);
+}
+
+/**************************************************************************
+...  
+**************************************************************************/
+static struct impr_effect *load_effects(const char *secname, const char *name,
+					struct section_file *file,
+					bool unit_effects, bool all_survive)
+{
+  int count, j, k;
+  char *item;
+  struct impr_effect *effects, *e;
+  const char *filename = secfile_filename(file);
+  bool problem;
+
+  for (count = 0;
+       secfile_lookup_str_default(file, NULL, "%s.effect%d.type", secname,
+				  count); count++) {
+    /* nothing */
+  }
+
+  if (count > MAX_EFFECTS) {
+    freelog(LOG_FATAL, "For %s maximum number of effects (%d) exceeded",
+            name, MAX_EFFECTS);
+    exit(EXIT_FAILURE);
+  }
+
+  effects = fc_malloc((count + 1) * sizeof(struct impr_effect));
+  k = 0;
+  for (j = 0; j < count; j++) {
+    e = &effects[k];
+    problem = FALSE;
+
+    item = secfile_lookup_str(file, "%s.effect%d.type", secname, j);
+    e->type = effect_type_from_str(item);
+    if (e->type == EFT_LAST) {
+      freelog(LOG_ERROR,
+	      "for %s effect[%d].type couldn't match type \"%s\" (%s)",
+	      name, j, item, filename);
+      problem = TRUE;
+    }
+
+    item = secfile_lookup_str_default(file, "None",
+				      "%s.effect%d.range", secname, j);
+    e->range = effect_range_from_str(item);
+    if (e->range == EFR_LAST) {
+      freelog(LOG_ERROR,
+	      "for %s effect[%d].range couldn't match range \"%s\" (%s)",
+	      name, j, item, filename);
+      problem = TRUE;
+    }
+    if (unit_effects) {
+      if (e->range != EFR_NONE) {
+	freelog(LOG_ERROR,
+	        "for %s effect ranges are not currently supported (%s)",
+	        name, filename);
+	problem = TRUE;
+      }
+    }
+
+    /* For some effects the range doesn't really matter - so we fix it
+       to the most convenient range for the code to deal with */
+    switch(e->type) {
+    case EFT_ADV_PARASITE:
+    case EFT_HAVE_EMBASSIES:
+    case EFT_REVEAL_CITIES:
+    case EFT_REVEAL_MAP:
+    case EFT_NO_ANARCHY:
+    case EFT_ANY_GOVERNMENT:
+      e->range = EFR_PLAYER; break;
+    case EFT_GIVE_IMM_ADV:
+      e->range = EFR_CITY; break;
+    default:
+      break;
+    }
+
+    e->amount = secfile_lookup_int_default(file, 0, "%s.effect%d.amount",
+					   secname, j);
+
+    if (all_survive) {
+      e->survives = 1;
+    } else {
+      e->survives = secfile_lookup_int_default(file, 0, "%s.effect%d.survives",
+					       secname, j);
+    }
+    e->outside = secfile_lookup_int_default(file, 0, "%s.effect%d.outside",
+					    secname, j);
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_bldg",
+				      secname, j);
+    if (*item != '\0') {
+      e->cond_bldg = find_improvement_by_name(item);
+      if (e->cond_bldg == B_LAST) {
+	freelog(LOG_ERROR, "for %s effect[%d].cond_bldg couldn't match "
+			   "improvement \"%s\" (%s)",
+		name, j, item, filename);
+	problem = TRUE;
+      }
+    } else {
+      e->cond_bldg = B_LAST;
+    }
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_gov",
+				      secname, j);
+    if (*item != '\0') {
+      struct government *g = find_government_by_name(item);
+      if (!g) {
+	freelog(LOG_ERROR, "for %s effect[%d].cond_gov couldn't match "
+			   "government \"%s\" (%s)",
+		name, j, item, filename);
+	e->cond_gov = game.government_count;
+	problem = TRUE;
+      } else {
+	e->cond_gov = g->index;
+      }
+    } else {
+      e->cond_gov = game.government_count;
+    }
+
+    item = secfile_lookup_str_default(file, "None", "%s.effect%d.cond_adv",
+				      secname, j);
+    if (*item != '\0') {
+      e->cond_adv = find_tech_by_name(item);
+      if (e->cond_adv == A_LAST) {
+	freelog(LOG_ERROR,
+		"for %s effect[%d].cond_adv couldn't match tech \"%s\" (%s)",
+		name, j, item, filename);
+	problem = TRUE;
+      }
+    } else {
+      e->cond_adv = A_NONE;
+    }
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_eff",
+				      secname, j);
+    if (*item != '\0') {
+      e->cond_eff = effect_type_from_str(item);
+      if (e->cond_eff == EFT_LAST) {
+	freelog(LOG_ERROR,
+		"for %s effect[%d].cond_eff couldn't match effect \"%s\" (%s)",
+		name, j, item, filename);
+	problem = TRUE;
+      }
+    } else {
+      e->cond_eff = EFT_LAST;
+    }
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.aff_unit",
+				      secname, j);
+    e->aff_unit = UCL_LAST;
+    if (*item != '\0') {
+      int index;
+
+      index = unit_flag_from_str(item);
+      if (index != F_MAX) {
+	e->aff_unit = index;
+      } else {
+	index = unit_move_type_from_str(item);
+	if (index > 0) {
+	  e->aff_unit = F_MAX + index;
+	} else {
+	  freelog(LOG_ERROR,
+		  "for %s effect[%d].aff_unit couldn't match type \"%s\" (%s)",
+		  name, j, item, filename);
+	  problem = TRUE;
+	}
+      }
+    }
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.aff_terr",
+				      secname, j);
+    if (*item != '\0') {
+      if (0 == strcmp("None", item)) {
+	e->aff_terr = T_LAST;
+      } else {
+	e->aff_terr = get_terrain_by_name(item);
+	if (e->aff_terr >= T_UNKNOWN) {
+	  freelog(LOG_ERROR, "for %s effect[%d].aff_terr couldn't match "
+			     "terrain \"%s\" (%s)",
+		  name, j, item, filename);
+	  e->aff_terr = T_LAST;
+	  problem = TRUE;
+	}
+      }
+    } else {
+      e->aff_terr = T_UNKNOWN;
+    }
+
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.aff_spec",
+				      secname, j);
+    if (*item != '\0') {
+      if (0 == strcmp("None", item)) {
+	e->aff_spec = S_NO_SPECIAL;
+      } else {
+	e->aff_spec = get_special_by_name(item);
+	if (e->aff_spec == S_NO_SPECIAL) {
+	  freelog(LOG_ERROR, "for %s effect[%d].aff_spec couldn't match "
+	      		     "special \"%s\" (%s)",
+		  name, j, item, filename);
+	  problem = TRUE;
+	}
+      }
+    } else {
+      e->aff_spec = S_ALL;
+    }
+
+    if (!problem) {
+       k++;
+    }
+  }
+  effects[k].type = EFT_LAST;
+
+  return effects;
+}
+
+/**************************************************************************
 ...  
 **************************************************************************/
 static void load_ruleset_units(struct section_file *file)
@@ -763,6 +1000,8 @@
     u->food_cost   = secfile_lookup_int(file, "%s.uk_food", sec[i]);
     u->gold_cost   = secfile_lookup_int(file, "%s.uk_gold", sec[i]);
 
+    u->effect = load_effects(sec[i], u->name, file, TRUE, FALSE);
+
     u->helptext = lookup_helptext(file, sec[i]);
   } unit_type_iterate_end;
   
@@ -779,7 +1018,7 @@
 	continue;
       }
 	ival = unit_flag_from_str(sval);
-      if (ival==F_LAST) {
+      if (ival==F_MAX) {
 	freelog(LOG_ERROR, "for unit_type \"%s\": bad flag name \"%s\" (%s)",
 	     u->name, sval, filename);
       }
@@ -961,8 +1200,10 @@
   }
   /* FIXME: Remove this restriction when gen-impr implemented. */
   if (nval != B_LAST_ENUM) {
-    freelog(LOG_FATAL, "Bad number of buildings %d (%s)", nval, filename);
-    exit(EXIT_FAILURE);
+    freelog(LOG_ERROR, _("ERROR! Bad number of buildings %d (%s). Although "
+            "this should still work, many building effects are still "
+            "hardcoded, and as such your modified buildings may not behave as "
+            "expected. Proceed with caution!"), nval, filename);
   }
   /* REMOVE TO HERE when gen-impr implemented. */
   game.num_impr_types = nval;
@@ -984,9 +1225,7 @@
   char *datafile_options;
   char **sec, *item, **list;
   int i, j, k, nval, count;
-  bool problem;
   struct impr_type *b;
-  struct impr_effect *e;
   const char *filename = secfile_filename(file);
 
   datafile_options = check_ruleset_capabilities(file, "+1.10.1", filename);
@@ -1093,164 +1332,7 @@
 
     b->sabotage = secfile_lookup_int(file, "%s.sabotage", sec[i]);
 
-    for (count = 0;
-	 secfile_lookup_str_default(file, NULL, "%s.effect%d.type", sec[i],
-				    count); count++) {
-      /* nothing */
-    }
-
-    if (count>MAX_EFFECTS) {
-      freelog(LOG_FATAL, "For %s maximum number of effects (%d) exceeded",
-              b->name, MAX_EFFECTS);
-      exit(EXIT_FAILURE);
-    }
-
-    b->effect = fc_malloc((count + 1) * sizeof(b->effect[0]));
-    k = 0;
-    for (j = 0; j < count; j++) {
-      e = &b->effect[k];
-      problem = FALSE;
-
-      item = secfile_lookup_str(file, "%s.effect%d.type", sec[i], j);
-      e->type = effect_type_from_str(item);
-      if (e->type == EFT_LAST) {
-	freelog(LOG_ERROR,
-		"for %s effect[%d].type couldn't match type \"%s\" (%s)",
-		b->name, j, item, filename);
-	problem = TRUE;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "None", "%s.effect%d.range", sec[i], j);
-      e->range = effect_range_from_str(item);
-      if (e->range == EFR_LAST) {
-	freelog(LOG_ERROR,
-		"for %s effect[%d].range couldn't match range \"%s\" (%s)",
-		b->name, j, item, filename);
-	problem = TRUE;
-      }
-
-      e->amount =
-	secfile_lookup_int_default(file, 0, "%s.effect%d.amount", sec[i], j);
-
-      e->survives =
-	secfile_lookup_int_default(file, 0, "%s.effect%d.survives", sec[i], j);
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.cond_bldg", sec[i], j);
-      if (*item != '\0') {
-	e->cond_bldg = find_improvement_by_name(item);
-	if (e->cond_bldg == B_LAST) {
-	  freelog(LOG_ERROR,
-		  "for %s effect[%d].cond_bldg couldn't match improvement \"%s\" (%s)",
-		  b->name, j, item, filename);
-	  problem = TRUE;
-	}
-      } else {
-	e->cond_bldg = B_LAST;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.cond_gov", sec[i], j);
-      if (*item != '\0') {
-	struct government *g = find_government_by_name(item);
-	if (!g) {
-	  freelog(LOG_ERROR,
-		  "for %s effect[%d].cond_gov couldn't match government \"%s\" (%s)",
-		  b->name, j, item, filename);
-	  e->cond_gov = game.government_count;
-	  problem = TRUE;
-	} else {
-	  e->cond_gov = g->index;
-	}
-      } else {
-	e->cond_gov = game.government_count;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "None", "%s.effect%d.cond_adv", sec[i], j);
-      if (*item != '\0') {
-	e->cond_adv = find_tech_by_name(item);
-	if (e->cond_adv == A_LAST) {
-	  freelog(LOG_ERROR,
-		  "for %s effect[%d].cond_adv couldn't match tech \"%s\" (%s)",
-		  b->name, j, item, filename);
-	  problem = TRUE;
-	}
-      } else {
-	e->cond_adv = A_NONE;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.cond_eff", sec[i], j);
-      if (*item != '\0') {
-	e->cond_eff = effect_type_from_str(item);
-	if (e->cond_eff == EFT_LAST) {
-	  freelog(LOG_ERROR,
-		  "for %s effect[%d].cond_eff couldn't match effect \"%s\" (%s)",
-		  b->name, j, item, filename);
-	  problem = TRUE;
-	}
-      } else {
-	e->cond_eff = EFT_LAST;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.aff_unit", sec[i], j);
-      if (*item != '\0') {
-	e->aff_unit = unit_class_from_str(item);
-	if (e->aff_unit == UCL_LAST) {
-	  freelog(LOG_ERROR,
-		  "for %s effect[%d].aff_unit couldn't match class \"%s\" (%s)",
-		  b->name, j, item, filename);
-	  problem = TRUE;
-	}
-      } else {
-	e->aff_unit = UCL_LAST;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.aff_terr", sec[i], j);
-      if (*item != '\0') {
-	if (0 == strcmp("None", item)) {
-	  e->aff_terr = T_LAST;
-	} else {
-	  e->aff_terr = get_terrain_by_name(item);
-	  if (e->aff_terr >= T_UNKNOWN) {
-	    freelog(LOG_ERROR,
-		    "for %s effect[%d].aff_terr couldn't match terrain \"%s\" (%s)",
-		    b->name, j, item, filename);
-	    e->aff_terr = T_LAST;
-	    problem = TRUE;
-	  }
-	}
-      } else {
-	e->aff_terr = T_UNKNOWN;
-      }
-
-      item =
-	secfile_lookup_str_default(file, "", "%s.effect%d.aff_spec", sec[i], j);
-      if (*item != '\0') {
-	if (0 == strcmp("None", item)) {
-	  e->aff_spec = S_NO_SPECIAL;
-	} else {
-	  e->aff_spec = get_special_by_name(item);
-	  if (e->aff_spec == S_NO_SPECIAL) {
-	    freelog(LOG_ERROR,
-		    "for %s effect[%d].aff_spec couldn't match special \"%s\" (%s)",
-		    b->name, j, item, filename);
-	    problem = TRUE;
-	  }
-	}
-      } else {
-	e->aff_spec = S_ALL;
-      }
-
-      if (!problem) {
-	k++;
-      }
-    }
-    b->effect[k].type = EFT_LAST;
+    b->effect = load_effects(sec[i], b->name, file, FALSE, FALSE);
 
     /* FIXME: remove when gen-impr obsoletes */
     b->variant = secfile_lookup_int_default(file, 0, "%s.variant", sec[i]);
@@ -1268,6 +1350,19 @@
     b->helptext = lookup_helptext(file, sec[i]);
   }
 
+  /* Nasty kludge to let old code which assumes B_PALACE and B_CITY work */
+  B_PALACE = get_improvement_for_effect(NULL, EFT_CAPITAL_CITY, NULL);
+  if (B_PALACE == B_LAST) {
+    freelog(LOG_ERROR, "Cannot find any capital city improvement");
+    exit(EXIT_FAILURE);
+  }
+
+  B_CITY = get_improvement_for_effect(NULL, EFT_UNIT_DEFEND, NULL);
+  if (B_CITY == B_LAST) {
+    freelog(LOG_ERROR, "Cannot find any city walls improvement");
+    exit(EXIT_FAILURE);
+  }
+
   /* Some more consistency checking: */
   impr_type_iterate(i) {
     b = &improvement_types[i];
@@ -1657,6 +1752,8 @@
       = secfile_lookup_int(file, "%s.production_shield_penalty,1", sec[i]);
     g->celeb_food_before_penalty
       = secfile_lookup_int(file, "%s.production_food_penalty,1", sec[i]);
+
+    g->effect = load_effects(sec[i], g->name, file, FALSE, TRUE);
     
     g->helptext = lookup_helptext(file, sec[i]);
   }
@@ -1808,6 +1905,7 @@
   packet.government_when_anarchy = game.government_when_anarchy;
   packet.default_government = game.default_government;
 
+  packet.num_unit_flags = game.num_unit_flags;
   packet.num_unit_types = game.num_unit_types;
   packet.num_impr_types = game.num_impr_types;
   packet.num_tech_types = game.num_tech_types;
@@ -2261,6 +2359,8 @@
     }
     pl->goals.government = val;
 
+    pl->effect = load_effects(sec[i], pl->name, file, FALSE, TRUE);
+
     /* read "normal" city names */
 
     pl->city_names = load_city_name_list(file, sec[i], ".cities");
@@ -2521,6 +2621,7 @@
     packet.paratroopers_range = u->paratroopers_range;
     packet.paratroopers_mr_req = u->paratroopers_mr_req;
     packet.paratroopers_mr_sub = u->paratroopers_mr_sub;
+    packet.effect = u->effect;       /* pointer assignment */
     packet.helptext = u->helptext;   /* pointer assignment */
 
     lsend_packet_ruleset_unit(dest, &packet);
@@ -2728,6 +2829,7 @@
     sz_strlcpy(gov.graphic_str, g->graphic_str);
     sz_strlcpy(gov.graphic_alt, g->graphic_alt);
     
+    gov.effect = g->effect;       /* pointer assignment */
     gov.helptext = g->helptext;   /* pointer assignment */
       
     lsend_packet_ruleset_government(dest, &gov);
@@ -2777,6 +2879,8 @@
     sz_strlcpy(packet.class, n->class);
     sz_strlcpy(packet.legend, n->legend);
 
+    packet.effect = n->effect;       /* pointer assignment */
+
     lsend_packet_ruleset_nation(dest, &packet);
   }
 }
@@ -2858,6 +2962,7 @@
 
   openload_ruleset_file(&unitfile, "units");
   load_unit_names(&unitfile);
+  load_unit_userflags(&unitfile);
 
   openload_ruleset_file(&terrfile, "terrain");
   load_terrain_names(&terrfile);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/savegame.c freeciv-patched/server/savegame.c
--- freeciv-cvs/server/savegame.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/server/savegame.c	2003-06-30 12:18:03.000000000 +0100
@@ -157,7 +157,7 @@
    and rulesets */
 #define SAVEFILE_OPTIONS "startoptions spacerace2 rulesets" \
 " diplchance_percent worklists2 map_editor known32fix turn " \
-"attributes watchtower rulesetdir client_worklists"
+"attributes watchtower rulesetdir client_worklists impr_gen"
 
 static const char hex_chars[] = "0123456789abcdef";
 static const char terrain_chars[] = "adfghjm prstu";
@@ -615,6 +615,18 @@
   plr->city_style=secfile_lookup_int_default(file, get_nation_city_style(plr->nation),
                                              "player%d.city_style", plrno);
 
+  if (has_capability("impr_gen", savefile_options)) {
+    /* destroyed wonders: */
+    p = secfile_lookup_str_default(file, "", "player%d.destroyed_wonders",
+                                   plrno);
+    for (i = 0; i < game.num_impr_types && p[i] != '\0'; i++) {
+      if (p[i] == '1') {
+	game.global_wonders[i] = -1; /* destroyed! */
+        add_destroyed_improvement(plr, i);
+      }
+    }
+  }
+
   plr->nturns_idle=0;
   plr->is_male=secfile_lookup_bool_default(file, TRUE, "player%d.is_male", plrno);
   plr->is_alive=secfile_lookup_bool(file, "player%d.is_alive", plrno);
@@ -887,6 +899,16 @@
 
     unit_list_init(&pcity->units_supported);
 
+    /* Initialise list of improvements with City- and Building-wide
+       equiv_ranges */
+    improvement_status_init(pcity->improvements,
+			    ARRAY_SIZE(pcity->improvements));
+
+    /* Initialise city's vector of improvement effects. */
+    ceff_vector_init(&pcity->effects);
+
+    update_city_bonuses(pcity);
+
     /* Initialize pcity->city_map[][], using set_worker_city() so that
        ptile->worked gets initialized correctly.  The pre-initialisation
        to C_TILE_EMPTY is necessary because set_worker_city() accesses
@@ -935,11 +957,6 @@
 
     p=secfile_lookup_str(file, "player%d.c%d.improvements", plrno, i);
 
-    /* Initialise list of improvements with City- and Building-wide
-       equiv_ranges */
-    improvement_status_init(pcity->improvements,
-			    ARRAY_SIZE(pcity->improvements));
-
     impr_type_iterate(x) {
       if (*p != '\0' && *p++=='1') {
         city_add_improvement(pcity,x);
@@ -1291,6 +1308,26 @@
 }
 
 /***************************************************************
+  Makes a list of any destroyed improvements
+***************************************************************/
+static void make_destroyed_list(char *temp, struct ceff_vector *ceff)
+{
+  int i, efflen = ceff_vector_size(ceff);
+
+  for (i = 0; i < game.num_impr_types; i++) {
+    temp[i] = '0';
+  }
+
+  for (i = 0; i < efflen; i++) {
+    struct eff_city *eff;
+
+    eff = ceff_vector_get(ceff, i);
+    temp[eff->impr] = '1';
+  }
+  temp[game.num_impr_types] = '\0';
+}
+
+/***************************************************************
 ...
 ***************************************************************/
 static void player_save(struct player *plr, int plrno,
@@ -1299,6 +1336,7 @@
   int i;
   char invs[A_LAST+1];
   struct player_spaceship *ship = &plr->spaceship;
+  char temp[B_LAST + 1];
 
   secfile_insert_str(file, plr->name, "player%d.name", plrno);
   secfile_insert_str(file, plr->username, "player%d.username", plrno);
@@ -1570,6 +1608,10 @@
   }
   city_list_iterate_end;
 
+  /* destroyed wonders: */
+  make_destroyed_list(temp, &plr->destroyed_effects);
+  secfile_insert_str(file, temp, "player%d.destroyed_wonders", plrno);
+
   /********** Put the players private map **********/
  /* Otherwise the player can see all, and there's no reason to save the private map. */
   if (game.fogofwar
@@ -2105,6 +2147,7 @@
       }
       if (string[i] == '1') {
 	game.global_wonders[i] = -1; /* destroyed! */
+        add_destroyed_improvement(NULL, i);
       }
     } impr_type_iterate_end;
   out:
@@ -2162,8 +2205,19 @@
   }
 
   if (!game.is_new_game) {
+    players_iterate(pplayer) {
+      player_update_global_effects(pplayer);
+    } players_iterate_end;
+
     /* Set active city improvements/wonders and their effects */
-    improvements_update_obsolete();
+    update_all_effects();
+
+    /* Make sure the move/hitpoint modifiers are set */
+    players_iterate(pplayer) {
+      unit_list_iterate(pplayer->units, punit) {
+	unit_update_modifiers(pplayer, punit);
+      } unit_list_iterate_end;
+    } players_iterate_end;
   }
 
   game.player_idx=0;
@@ -2180,7 +2234,6 @@
   int i;
   int version;
   char options[512];
-  char temp[B_LAST+1];
 
   version = MAJOR_VERSION *10000 + MINOR_VERSION *100 + PATCH_VERSION; 
   secfile_insert_int(file, version, "game.version");
@@ -2326,16 +2379,10 @@
 
   secfile_insert_bool(file, game.save_options.save_players, "game.save_players");
   if (game.save_options.save_players) {
+    char temp[B_LAST + 1];
+
     /* destroyed wonders: */
-    impr_type_iterate(i) {
-      if (is_wonder(i) && game.global_wonders[i]!=0
-	  && !find_city_by_id(game.global_wonders[i])) {
-	temp[i] = '1';
-      } else {
-	temp[i] = '0';
-      }
-    } impr_type_iterate_end;
-    temp[game.num_impr_types] = '\0';
+    make_destroyed_list(temp, &game.destroyed_effects);
     secfile_insert_str(file, temp, "game.destroyed_wonders");
 
     calc_unit_ordering();
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/settlers.c freeciv-patched/server/settlers.c
--- freeciv-cvs/server/settlers.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/server/settlers.c	2003-06-30 12:16:50.000000000 +0100
@@ -861,8 +861,7 @@
     struct city *pcity = map_get_city(punit->x, punit->y);
 
     assert(pcity != NULL);
-    cost = city_granary_size(pcity->size);
-    if (city_got_effect(pcity, B_GRANARY)) { cost /= 2; }
+    cost = city_granary_size(pcity->size) * (100 - pcity->growth_food) / 100;
   }
 
   return cost;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/srv_main.c freeciv-patched/server/srv_main.c
--- freeciv-cvs/server/srv_main.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/server/srv_main.c	2003-06-30 12:18:03.000000000 +0100
@@ -295,41 +295,37 @@
 }
 
 /**************************************************************************
-...
-**************************************************************************/
-static void do_apollo_program(void)
-{
-  struct city *pcity = find_city_wonder(B_APOLLO);
-
-  if (pcity) {
-    struct player *pplayer = city_owner(pcity);
-
-    if (game.civstyle == 1) {
-      players_iterate(other_player) {
-	city_list_iterate(other_player->cities, pcity) {
-	  show_area(pplayer, pcity->x, pcity->y, 0);
-	} city_list_iterate_end;
-      } players_iterate_end;
-    } else {
-      map_know_all(pplayer);
-      send_all_known_tiles(&pplayer->connections);
-      send_all_known_cities(&pplayer->connections);
-    }
-  }
-}
-
-/**************************************************************************
-...
+  Carries out any actions that affect the whole world - e.g. Marco Polo,
+  Apollo Program
 **************************************************************************/
-static void marco_polo_make_contact(void)
+static void check_global_effects(void)
 {
-  struct city *pcity = find_city_wonder(B_MARCO);
 
-  if (pcity) {
-    players_iterate(pplayer) {
-      make_contact(city_owner(pcity), pplayer, pcity->x, pcity->y);
-    } players_iterate_end;
-  }
+  players_iterate(pplayer) {
+    impr_effects_iterate(iter, B_LAST, NULL, pplayer) {
+      switch(iter.imeff->type) {
+      case EFT_HAVE_EMBASSIES:
+        players_iterate(othplayer) {
+          make_contact(pplayer, othplayer, -1, -1);
+        } players_iterate_end;
+        break;
+      case EFT_REVEAL_MAP:
+        map_know_all(pplayer);
+        send_all_known_tiles(&pplayer->connections);
+        send_all_known_cities(&pplayer->connections);
+        break;
+      case EFT_REVEAL_CITIES:
+        players_iterate(othplayer) {
+	  city_list_iterate(othplayer->cities, pcity) {
+	    show_area(pplayer, pcity->x, pcity->y, 0);
+	  } city_list_iterate_end;
+        } players_iterate_end;
+        break;
+      default:
+        break;
+      }
+    } impr_effects_iterate_end;
+  } players_iterate_end;
 }
 
 /**************************************************************************
@@ -522,8 +518,7 @@
 			     &game.nuclearwinter, &game.coolinglevel,
 			     nuclear_winter);
   update_diplomatics();
-  do_apollo_program();
-  marco_polo_make_contact();
+  check_global_effects();
   make_history_report();
   send_player_turn_notifications(NULL);
   freelog(LOG_DEBUG, "Turn ended.");
@@ -1727,6 +1722,7 @@
       init_tech(pplayer, game.tech);
       player_limit_to_government_rates(pplayer);
       pplayer->economic.gold = game.gold;
+      player_update_global_effects(pplayer);
     } players_iterate_end;
     game.max_players = game.nplayers;
 
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/unithand.c freeciv-patched/server/unithand.c
--- freeciv-cvs/server/unithand.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/server/unithand.c	2003-06-30 12:16:57.000000000 +0100
@@ -160,7 +160,7 @@
 {
   const Unit_Type_id from_unittype = packet->type;
   const Unit_Type_id to_unittype = can_upgrade_unittype(pplayer,
-							from_unittype);
+							from_unittype, TRUE);
 
   if (to_unittype == -1) {
     notify_player(pplayer,
@@ -228,7 +228,7 @@
     return;
   }
   from_unit = punit->type;
-  if((to_unit=can_upgrade_unittype(pplayer, punit->type)) == -1) {
+  if((to_unit=can_upgrade_unittype(pplayer, punit->type, TRUE)) == -1) {
     notify_player(pplayer, _("Game: Illegal package, can't upgrade %s (yet)."), 
 		  unit_type(punit)->name);
     return;
@@ -507,15 +507,9 @@
     break;
   case AB_NO_AQUEDUCT:
     notify_player_ex(pplayer, punit->x, punit->y, E_NOEVENT,
-		     _("Game: %s needs %s to grow, so you cannot add %s."),
-		     pcity->name, get_improvement_name(B_AQUEDUCT),
-		     unit_name);
-    break;
-  case AB_NO_SEWER:
-    notify_player_ex(pplayer, punit->x, punit->y, E_NOEVENT,
-		     _("Game: %s needs %s to grow, so you cannot add %s."),
-		     pcity->name, get_improvement_name(B_SEWER),
-		     unit_name);
+		     _("Game: %s needs an improvement to grow, so "
+		       "you cannot add %s."),
+		     pcity->name, unit_name);
     break;
   default:
     /* Shouldn't happen */
@@ -737,7 +731,7 @@
   if (punit->hp &&
       (pcity=map_get_city(def_x, def_y)) &&
       pcity->size>1 &&
-      !city_got_citywalls(pcity) &&
+      !is_under_effect(B_LAST,pcity,NULL,EFT_UNIT_NO_LOSE_POP) &&
       kills_citizen_after_attack(punit)) {
     city_reduce_size(pcity,1);
     city_refresh(pcity);
